"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.theme = exports.default = exports.customLayout = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _ShortText = _interopRequireDefault(require("@material-ui/icons/ShortText"));

var _Home = _interopRequireDefault(require("@material-ui/icons/Home"));

var _VpnKey = _interopRequireDefault(require("@material-ui/icons/VpnKey"));

var _PersonPin = _interopRequireDefault(require("@material-ui/icons/PersonPin"));

var _Settings = _interopRequireDefault(require("@material-ui/icons/Settings"));

var _styles = require("@material-ui/core/styles");

var _blue = _interopRequireDefault(require("@material-ui/core/colors/blue"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var CustomUserMenu = function CustomUserMenu(props) {
  var permissions = sessionStorage.getItem('auth');
  var account_id = sessionStorage.getItem('account_id');
  var uid = sessionStorage.getItem('uid');
  var translate = (0, _reactAdmin.useTranslate)();
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.UserMenu, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.MenuItemLink, {
    to: "/",
    primaryText: "Home",
    leftIcon: /*#__PURE__*/_react.default.createElement(_Home.default, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.MenuItemLink, {
    to: "/about",
    primaryText: translate('ra.message.about'),
    leftIcon: /*#__PURE__*/_react.default.createElement(_ShortText.default, null)
  }), uid && /*#__PURE__*/_react.default.createElement(_reactAdmin.MenuItemLink, {
    to: '/person/' + uid,
    primaryText: translate('ra.auth.user_menu'),
    leftIcon: /*#__PURE__*/_react.default.createElement(_PersonPin.default, null)
  }), uid && account_id && /*#__PURE__*/_react.default.createElement(_reactAdmin.MenuItemLink, {
    to: '/account_password/' + uid,
    primaryText: translate('ra.auth.password'),
    leftIcon: /*#__PURE__*/_react.default.createElement(_VpnKey.default, null)
  }), permissions && permissions.match(/^admin/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.MenuItemLink, {
    to: '/settings/' + sessionStorage.getItem('settings_id'),
    primaryText: "Settings",
    leftIcon: /*#__PURE__*/_react.default.createElement(_Settings.default, null)
  }));
};

var CustomAppBar = function CustomAppBar(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.AppBar, _extends({}, props, {
    userMenu: /*#__PURE__*/_react.default.createElement(CustomUserMenu, null)
  }));
};

var theme = (0, _styles.createMuiTheme)({
  palette: {
    secondary: _blue.default,
    contrastThreshold: 3,
    tonalOffset: 0.2
  },
  sidebar: {
    width: 150,
    closedWidth: 55
  }
});
exports.theme = theme;

var customLayout = function customLayout(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Layout, _extends({}, props, {
    appBar: CustomAppBar
  }));
};

exports.customLayout = customLayout;
var _default = customLayout;
exports.default = _default;