"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loginExt = exports.default = void 0;

var _queryString = _interopRequireDefault(require("query-string"));

var _jwtDecode = _interopRequireDefault(require("jwt-decode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// created 28-mar-2021 by rich braun <docker@instantlinux.net>
// auth provider for external login
// TODO this page throws error
//  "Objects are not valid as a React child"
//  because I haven't yet learned what placeholder child elements are
var apiUrl = process.env.REACT_APP_API_URL;

var loginExt = function loginExt(props) {
  var query = _queryString.default.parse(props.location.search);

  var token = query.token;
  var decodedJwt = (0, _jwtDecode.default)(token);
  sessionStorage.setItem('uid', decodedJwt.sub);
  sessionStorage.setItem('token', decodedJwt.jti);
  sessionStorage.setItem('auth', decodedJwt.auth);
  sessionStorage.setItem('account_id', decodedJwt.acc);
  var request = new Request(apiUrl + '/auth_params', {
    headers: new Headers({
      Accept: 'application/json',
      Authorization: 'Basic ' + btoa(decodedJwt.sub + ':' + decodedJwt.jti),
      mode: 'no-cors'
    })
  });
  fetch(request).then(function (response) {
    if (response.status < 200 || response.status >= 300) {
      throw new Error(response.statusText);
    }

    return response.json();
  }).then(function (_ref) {
    var resources = _ref.resources,
        storage_id = _ref.storage_id,
        settings_id = _ref.settings_id;
    sessionStorage.setItem('resource_endpoints', JSON.stringify(resources));
    sessionStorage.setItem('settings_id', settings_id);
    sessionStorage.setItem('storage_id', storage_id);
    window.location = '/#/welcome';
  });
  return null;
};

exports.loginExt = loginExt;
var _default = loginExt;
exports.default = _default;