"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MediaInput = exports.MediaGallery = void 0;

var _react = _interopRequireDefault(require("react"));

var Dropzone = _interopRequireWildcard(require("react-dropzone-uploader"));

var _reactImageGallery = _interopRequireDefault(require("react-image-gallery"));

require("react-dropzone-uploader/dist/styles.css");

require("react-image-gallery/styles/css/image-gallery.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function Headers() {
  return {
    Accept: 'application/json',
    'Content-Type': 'application/json',
    Authorization: 'Basic ' + btoa(sessionStorage.getItem('uid') + ':' + sessionStorage.getItem('token')),
    mode: 'no-cors'
  };
}

var MediaInput = function MediaInput(props) {
  var storage_id = sessionStorage.getItem('storage_id');
  var mediaUrl = JSON.parse(sessionStorage.getItem('resource_endpoints'))['file'];

  var getUploadParams = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
      var _ref$meta, duration, height, lastModifiedDate, name, size, type, videoHeight, videoWidth, width, params, api, get_presigned;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _ref$meta = _ref.meta, duration = _ref$meta.duration, height = _ref$meta.height, lastModifiedDate = _ref$meta.lastModifiedDate, name = _ref$meta.name, size = _ref$meta.size, type = _ref$meta.type, videoHeight = _ref$meta.videoHeight, videoWidth = _ref$meta.videoWidth, width = _ref$meta.width;

              if (['video/mp4', 'video/mpeg'].includes(type)) {
                params = {
                  storage_id: storage_id,
                  content_type: type,
                  duration: duration,
                  height: videoHeight,
                  modified: lastModifiedDate,
                  name: name,
                  parent_id: props.parent_id,
                  size: size,
                  width: videoWidth
                };
              } else {
                params = {
                  storage_id: storage_id,
                  content_type: type,
                  height: height,
                  modified: lastModifiedDate,
                  name: name,
                  parent_id: props.parent_id,
                  size: size,
                  width: width
                };
              }

              _context.next = 4;
              return fetch(mediaUrl + '/file_upload_url', {
                body: JSON.stringify(params),
                headers: Headers(),
                method: 'POST'
              });

            case 4:
              api = _context.sent;
              _context.next = 7;
              return api.json();

            case 7:
              get_presigned = _context.sent;
              return _context.abrupt("return", {
                fields: get_presigned.params,
                meta: {
                  fileId: get_presigned.file_id
                },
                url: get_presigned.upload_url
              });

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getUploadParams(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleChangeStatus = function handleChangeStatus(_ref3, status) {
    var meta = _ref3.meta;

    // console.log(status, meta)
    if (['aborted', 'done', 'error_upload'].includes(status)) {
      fetch(mediaUrl + '/upload_complete/' + meta.fileId + '?status=' + status, {
        headers: Headers(),
        method: 'POST'
      });
    }
  };

  var handleSubmit = function handleSubmit(files, allFiles) {
    // console.log(files.map(f => f.meta))
    allFiles.forEach(function (f) {
      return f.remove();
    });
  };

  return (
    /*#__PURE__*/
    // TODO alternative to this .default syntax
    _react.default.createElement(Dropzone.default, {
      // eslint-disable-line
      getUploadParams: getUploadParams,
      inputContent: "Drop photos or click here",
      inputWithFilesContent: "Add another  ",
      maxFiles: 10,
      maxSizeBytes: 31457280,
      minSizeBytes: 1024,
      multiple: true,
      onChangeStatus: handleChangeStatus,
      onSubmit: handleSubmit,
      styles: {
        dropzone: {
          minHeight: 200,
          maxHeight: 250
        }
      },
      accept: "image/*,video/*"
    })
  );
};

exports.MediaInput = MediaInput;

var GalleryView = /*#__PURE__*/function (_React$Component) {
  _inherits(GalleryView, _React$Component);

  var _super = _createSuper(GalleryView);

  // This class exists solely to fetch media before displaying
  // ImageGallery; dataProvider only has the album record, not
  // the media details
  function GalleryView(props) {
    var _this;

    _classCallCheck(this, GalleryView);

    _this = _super.call(this, props);
    _this.state = {
      album_id: props.id,
      isLoading: true,
      media: [],
      mediaUrl: JSON.parse(sessionStorage.getItem('resource_endpoints'))['file'],
      error: null
    };
    return _this;
  }

  _createClass(GalleryView, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      fetch(this.state.mediaUrl + '/album/' + this.state.album_id + '?details=true', {
        headers: Headers()
      }).then(function (response) {
        if (response.ok) {
          return response.json();
        } else {
          throw new Error("error=".concat(response.json().message, " status=").concat(response.status));
        }
      }).then(function (data) {
        return _this2.setState({
          isLoading: false,
          media: data.media
        });
      }).catch(function (error) {
        return _this2.setState({
          error: error,
          isLoading: false
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          isLoading = _this$state.isLoading,
          media = _this$state.media,
          error = _this$state.error;

      if (error) {
        return /*#__PURE__*/_react.default.createElement("span", null, error.message);
      }

      if (isLoading) {
        return /*#__PURE__*/_react.default.createElement("span", null, "Loading");
      } else {
        return /*#__PURE__*/_react.default.createElement(_reactImageGallery.default, {
          items: media,
          thumbnailPosition: "right",
          showIndex: true
        });
      }
    }
  }]);

  return GalleryView;
}(_react.default.Component);

var MediaGallery = function MediaGallery(_ref4) {
  var record = _ref4.record;
  return /*#__PURE__*/_react.default.createElement(GalleryView, {
    id: record.id
  });
};

exports.MediaGallery = MediaGallery;