"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prefs = exports.default = void 0;

var _queryString = _interopRequireDefault(require("query-string"));

var _jwtDecode = _interopRequireDefault(require("jwt-decode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Prefs link for update, accessed via magic-link URL
// created 5-may-2019 by rich braun <docker@instantlinux.net>
var apiUrl = process.env.REACT_APP_API_URL;

var prefs = function prefs(props) {
  var query = _queryString.default.parse(props.location.search);

  var guest_id = query.guest_id,
      magic = query.magic,
      cid = query.cid;
  var request = new Request(apiUrl + '/auth', {
    method: 'POST',
    body: JSON.stringify({
      guest_id: guest_id,
      magic: magic,
      cid: cid
    }),
    headers: new Headers({
      'Content-Type': 'application/json'
    })
  });
  return fetch(request).then(function (response) {
    if (response.status < 200 || response.status >= 300) {
      throw new Error(response.statusText);
    }

    return response.json();
  }).then(function (json) {
    var decodedJwt = (0, _jwtDecode.default)(json['jwt_token']);
    sessionStorage.setItem('uid', decodedJwt.sub);
    sessionStorage.setItem('token', decodedJwt.jti);
    sessionStorage.setItem('guest_id', json['guest_id']);
    sessionStorage.setItem('auth', decodedJwt.auth);
    window.location = '/#/person/' + decodedJwt.sub;
    window.location.reload(true);
  });
};

exports.prefs = prefs;
var _default = prefs;
exports.default = _default;