"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TopbarNoActions = exports.TopbarActions = exports.MenuTitle = exports.LocationRenderer = exports.ListPagination = exports.BottombarSaveOnly = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _excluded = ["basePath", "data"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// Pagination choice list
var ListPagination = function ListPagination(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Pagination, _extends({
    rowsPerPageOptions: [10, 20, 40, 100, 250]
  }, props));
}; // Location dropdowns


exports.ListPagination = ListPagination;

var LocationRenderer = function LocationRenderer(record) {
  if (record.name) {
    return "".concat(record.name, " - ").concat(record.city);
  } else if (record.address) {
    return "".concat(record.address, ", ").concat(record.city);
  } else if (record.neighborhood) {
    return record.neighborhood;
  } else {
    return record.city ? record.city : record.id;
  }
}; // Menu title with name instead of ID


exports.LocationRenderer = LocationRenderer;

var MenuTitle = function MenuTitle(_ref) {
  var record = _ref.record;
  return /*#__PURE__*/_react.default.createElement("span", null, record ? record.name : '');
}; // Top toolbar: enable edit if permissions allow


exports.MenuTitle = MenuTitle;

var TopbarActions = function TopbarActions(_ref2) {
  var basePath = _ref2.basePath,
      data = _ref2.data,
      props = _objectWithoutProperties(_ref2, _excluded);

  if (data && data.rbac && data.rbac.includes('u')) {
    return /*#__PURE__*/_react.default.createElement(_reactAdmin.TopToolbar, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.EditButton, {
      basePath: basePath,
      record: data
    }));
  } else {
    return /*#__PURE__*/_react.default.createElement(_reactAdmin.TopToolbar, null);
  }
}; // Top toolbar: disable all the standard buttons (for profile edit)


exports.TopbarActions = TopbarActions;

var TopbarNoActions = function TopbarNoActions(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.TopToolbar, null);
}; // Bottom toolbar: only show a save button, no delete button


exports.TopbarNoActions = TopbarNoActions;

var BottombarSaveOnly = function BottombarSaveOnly(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Toolbar, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SaveButton, null));
}; // Bottom toolbar: disable save/edit buttons - just use {null}


exports.BottombarSaveOnly = BottombarSaveOnly;