"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.accountShow = exports.accountSecurity = exports.accountList = exports.accountEdit = exports.accountCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _queryString = require("query-string");

var _raCustom = require("../lib/ra-custom");

var _validate = require("../lib/validate");

var _excluded = ["permissions"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var accountCreate = function accountCreate(props) {
  var _parse = (0, _queryString.parse)(props.location.search),
      forgot = _parse.forgot;

  var forgotbool = forgot === 'true';
  return /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true,
    direction: 'column',
    spacing: 2
  }, !forgotbool && /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xl: 6,
    md: 6,
    sm: 12,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement(_Card.default, null, /*#__PURE__*/_react.default.createElement(_CardContent.default, null, "Follow these steps to invite guests to your event:", /*#__PURE__*/_react.default.createElement("ul", null, /*#__PURE__*/_react.default.createElement("li", null, "Create a username"), /*#__PURE__*/_react.default.createElement("li", null, "Confirm your email"), /*#__PURE__*/_react.default.createElement("li", null, "Create a password"), /*#__PURE__*/_react.default.createElement("li", null, "Add your location"), /*#__PURE__*/_react.default.createElement("li", null, "Fill out the event form")), "You can also return here if you ever forget your password."))), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xl: 6,
    md: 6,
    sm: 12,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, _extends({}, props, {
    title: "Account Registration"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/confirmwait",
    toolbar: /*#__PURE__*/_react.default.createElement(RegisterToolbar, null)
  }, /*#__PURE__*/_react.default.createElement(RegisterForm, {
    forgot: forgotbool
  })))));
}; // TODO verify_password
// (value) => value === watch('new_password')


exports.accountCreate = accountCreate;

var accountSecurity = function accountSecurity(_ref) {
  var permissions = _ref.permissions,
      props = _objectWithoutProperties(_ref, _excluded);

  var uid = sessionStorage.getItem('uid');
  var auth = sessionStorage.getItem('auth'); // console.log('auth=' + sessionStorage.getItem('auth'))
  // TODO redirect to logout; it goes to Not Found unless set to /

  var redir = auth.includes('user') ? '/welcome?buttons=login' : '/';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(MenuUpdateTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, {
    redirect: redir
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "password"
  }, permissions && String(permissions).match(/user|pwchange/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "old_password",
    type: "password"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "new_password",
    type: "password",
    validate: _validate.validatePasswordOK
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "verify_password",
    type: "password",
    validate: _validate.validatePasswordOK
  }), permissions && !String(permissions).match(/user|pwchange/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "reset_token",
    defaultValue: sessionStorage.getItem('reset_token')
  }), permissions && String(permissions).match(/user|mfarequired/) && /*#__PURE__*/_react.default.createElement(CreateMFAButton, null)), permissions && String(permissions).match(/user/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "API keys",
    toolbar: null
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "apikey",
    target: "uid",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "prefix"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "expires"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  }))), /*#__PURE__*/_react.default.createElement(CreateAPIkeyButton, {
    uid: uid
  }))));
};

exports.accountSecurity = accountSecurity;

var accountShow = function accountShow(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Show, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    label: "Person",
    source: "uid",
    reference: "person"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name",
    label: "Username"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "last_login",
    showTime: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanField, {
    source: "totp",
    label: "MFA"
  })));
}; // TODO the grants tab doesn't work yet


exports.accountShow = accountShow;

var accountEdit = function accountEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "account"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    label: "Username",
    validate: _validate.validateUsername
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    source: "uid",
    reference: "person",
    label: "Personal details and contact info"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
    source: "password_must_change"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
    source: "totp",
    label: "MFA"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "status",
    choices: [{
      id: 'active',
      name: 'active'
    }, {
      id: 'disabled',
      name: 'disabled'
    }]
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "Grants"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "grant",
    target: "account_id",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: editGrant
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "value"
  }))))));
};

exports.accountEdit = accountEdit;

var accountList = function accountList(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.List, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "show"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    source: "uid",
    label: "User",
    reference: "person"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "last_login",
    showTime: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanField, {
    source: "totp",
    label: "MFA"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  })));
};

exports.accountList = accountList;

var editGrant = function editGrant(id) {
  var url = new URL(window.location.href);
  return "/grant/".concat(id, "?account_id=").concat(url.hash.split('/')[2]);
};

var MenuUpdateTitle = function MenuUpdateTitle(_ref2) {
  var record = _ref2.record;
  return /*#__PURE__*/_react.default.createElement("span", null, "Password Update - ", record.username);
};

var RegisterForm = /*#__PURE__*/function (_React$Component) {
  _inherits(RegisterForm, _React$Component);

  var _super = _createSuper(RegisterForm);

  function RegisterForm(props, context) {
    var _this;

    _classCallCheck(this, RegisterForm);

    _this = _super.call(this, props, context);
    _this.state = {
      forgot: props.forgot
    };
    return _this;
  }

  _createClass(RegisterForm, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
        source: "forgot_password",
        onChange: function onChange(e) {
          return _this2.setState(function (prevState) {
            return {
              forgot: !prevState.forgot
            };
          });
        },
        defaultValue: this.state.forgot
      }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
        source: "identity",
        label: "Email Address",
        fullWidth: true,
        validate: _validate.validateEmail
      }), /*#__PURE__*/_react.default.createElement("br", null), this.state.forgot || /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
        source: "name",
        label: "Your Full Name",
        fullWidth: true,
        validate: _validate.validateName
      }), /*#__PURE__*/_react.default.createElement("br", null), this.state.forgot || /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
        source: "username",
        label: "Unique Username",
        fullWidth: true,
        validate: _validate.validateUsername
      }));
    }
  }]);

  return RegisterForm;
}(_react.default.Component);

var RegisterToolbar = function RegisterToolbar(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Toolbar, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SaveButton, {
    label: "submit",
    submitOnEnter: true
  }));
}; // TODO this function (almost verbatim from the CreateEdit reference)
//   throws warning about forwardRef:
// Failed prop type: Invalid prop `component` supplied to
// `ForwardRef(ButtonBase)`. Expected an element type that can hold a ref.


var CreateAPIkeyButton = function CreateAPIkeyButton(_ref3) {
  var uid = _ref3.uid;
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactAdmin.Link,
    variant: "contained",
    to: {
      pathname: '/apikey/create',
      state: {
        record: {
          uid: uid
        }
      }
    }
  }, "Add");
};

var CreateMFAButton = function CreateMFAButton() {
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactAdmin.Link,
    variant: "contained",
    to: {
      pathname: '/mfa'
    }
  }, "MFA");
};

var _default = accountCreate;
exports.default = _default;