"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.apikeyEdit = exports.ApikeyCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _validate = require("../lib/validate");

var _raCustom = require("../lib/ra-custom");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var ApikeyCreate = function ApikeyCreate(props) {
  var redirect = (0, _reactAdmin.useRedirect)();

  var onSuccess = function onSuccess(_ref) {
    var data = _ref.data;
    sessionStorage.setItem('apikey', JSON.stringify(data));
    redirect('/apikeynew');
  };

  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, _extends({}, props, {
    title: "Create API key",
    onSuccess: onSuccess
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validate32String
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayInput, {
    label: "Scopes",
    source: "scopes",
    filter: {
      settings_id: sessionStorage.getItem('settings_id')
    },
    sort: {
      field: 'name',
      order: 'ASC'
    },
    reference: "scope",
    target: "scope_id"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteArrayInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateTimeInput, {
    source: "expires"
  })));
};

exports.ApikeyCreate = ApikeyCreate;

var apikeyEdit = function apikeyEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/person/".concat(sessionStorage.getItem('uid'), "/4")
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validate32String
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayInput, {
    label: "Scopes",
    source: "scopes",
    filter: {
      settings_id: sessionStorage.getItem('settings_id')
    },
    sort: {
      field: 'name',
      order: 'ASC'
    },
    reference: "scope",
    target: "scope_id"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteArrayInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "status",
    choices: [{
      id: 'active',
      name: 'active'
    }, {
      id: 'disabled',
      name: 'disabled'
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateTimeInput, {
    disabled: true,
    source: "expires"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateTimeInput, {
    disabled: true,
    source: "last_used"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "prefix"
  })));
};

exports.apikeyEdit = apikeyEdit;
var _default = ApikeyCreate;
exports.default = _default;