"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.contactEdit = exports.contactCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _constants = require("../lib/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var contactCreate = function contactCreate(props) {
  var _ref = typeof props.location.state !== 'undefined' && props.location.state.record,
      uid = _ref.uid;

  var redirect = uid ? "/person/".concat(uid, "/1") : 'show';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: redirect
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "type",
    choices: [{
      id: 'email',
      name: 'email'
    }, {
      id: 'linkedin',
      name: 'linkedin'
    }, {
      id: 'location',
      name: 'location'
    }, {
      id: 'messenger',
      name: 'messenger'
    }, {
      id: 'slack',
      name: 'slack'
    }, {
      id: 'sms',
      name: 'sms'
    }, {
      id: 'voice',
      name: 'voice'
    }, {
      id: 'whatsapp',
      name: 'whatsapp'
    }],
    defaultValue: "email"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "info",
    label: "Contact number/address"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "carrier",
    choices: [{
      id: null,
      name: 'Choose...'
    }, {
      id: 'att',
      name: 'AT&T'
    }, {
      id: 'sprint',
      name: 'Sprint'
    }, {
      id: 'tmobile',
      name: 'T-Mobile'
    }, {
      id: 'verizon',
      name: 'Verizon'
    }],
    defaultValue: null
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "label",
    choices: [{
      id: 'home',
      name: 'home'
    }, {
      id: 'mobile',
      name: 'mobile'
    }, {
      id: 'work',
      name: 'work'
    }, {
      id: 'other',
      name: 'other'
    }],
    defaultValue: "home"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "member"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
    source: "muted",
    defaultValue: false,
    label: "Mute notifications"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "uid",
    reference: "person",
    filter: {
      id: sessionStorage.getItem('uid')
    },
    label: "User",
    default_value: uid
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status",
    defaultValue: "unconfirmed"
  })));
};

exports.contactCreate = contactCreate;

var contactEdit = function contactEdit(props) {
  var uid = sessionStorage.getItem('uid');
  var redirect = uid ? "/person/".concat(uid, "/1") : '/list';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: redirect
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "info",
    label: "Contact number/address"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "type",
    choices: [{
      id: 'email',
      name: 'email'
    }, {
      id: 'linkedin',
      name: 'linkedin'
    }, {
      id: 'location',
      name: 'location'
    }, {
      id: 'messenger',
      name: 'messenger'
    }, {
      id: 'slack',
      name: 'slack'
    }, {
      id: 'sms',
      name: 'sms'
    }, {
      id: 'voice',
      name: 'voice'
    }, {
      id: 'whatsapp',
      name: 'whatsapp'
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "carrier",
    choices: [{
      id: 'att',
      name: 'AT&T'
    }, {
      id: 'sprint',
      name: 'Sprint'
    }, {
      id: 'tmobile',
      name: 'T-Mobile'
    }, {
      id: 'verizon',
      name: 'Verizon'
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "label",
    choices: [{
      id: 'home',
      name: 'home'
    }, {
      id: 'mobile',
      name: 'mobile'
    }, {
      id: 'work',
      name: 'work'
    }, {
      id: 'other',
      name: 'other'
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
    source: "muted",
    defaultValue: false,
    label: "Mute notifications"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    label: "User",
    source: "uid",
    reference: "person",
    filter: {
      id: sessionStorage.getItem('uid')
    }
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }))));
};

exports.contactEdit = contactEdit;

var MenuTitle = function MenuTitle(_ref2) {
  var record = _ref2.record;
  return /*#__PURE__*/_react.default.createElement("span", null, record ? "Contact ".concat(record.type, ": ").concat(record.info) : '');
};

var _default = contactCreate;
exports.default = _default;