"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.credentialEdit = exports.credentialCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _validate = require("../lib/validate");

var _vendors = _interopRequireDefault(require("../lib/vendors"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var credentialCreate = function credentialCreate(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/settings/".concat(sessionStorage.getItem('settings_id'), "/2")
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "vendor",
    choices: _vendors.default,
    validate: _validate.validateSelected
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "key",
    label: "Username or key ID"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "secret",
    type: "password"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "otherdata",
    label: "Other data",
    type: "password"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "type"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "url",
    label: "URL",
    type: "url"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateTimeInput, {
    source: "expires"
  })));
};

exports.credentialCreate = credentialCreate;

var credentialEdit = function credentialEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/settings/".concat(sessionStorage.getItem('settings_id'), "/2")
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "vendor",
    choices: _vendors.default,
    validate: _validate.validateSelected
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "key",
    label: "Username or key ID"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "secret",
    type: "password"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "otherdata",
    label: "Other data",
    type: "password"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "type"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "url",
    label: "URL",
    type: "url"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateTimeInput, {
    source: "expires"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "status",
    choices: [{
      id: 'active',
      name: 'active'
    }, {
      id: 'disabled',
      name: 'disabled'
    }]
  })));
};

exports.credentialEdit = credentialEdit;

var MenuTitle = function MenuTitle(_ref) {
  var record = _ref.record;
  return /*#__PURE__*/_react.default.createElement("span", null, record ? "".concat(record.vendor, " credential: ").concat(record.name) : '');
};

var _default = credentialCreate;
exports.default = _default;