"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.listShow = exports.listList = exports.listEdit = exports.listCreate = exports.default = exports.ListShowTabs = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _raInputRichText = _interopRequireDefault(require("ra-input-rich-text"));

var _reactMoment = _interopRequireDefault(require("react-moment"));

var _reactRouterDom = require("react-router-dom");

var _queryString = require("query-string");

var _constants = require("../lib/constants");

var _raCustom = require("../lib/ra-custom");

var _validate = require("../lib/validate");

var _excluded = ["record"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var listCreate = function listCreate(props) {
  var _parse = (0, _queryString.parse)(props.location.state),
      uid_string = _parse.uid;

  var uid = uid_string || '';
  var redirect = uid ? "/person/".concat(uid, "/show/lists") : 'show';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: redirect
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    label: "List",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_raInputRichText.default, {
    source: "description",
    toolbar: _constants.toolbarOpts
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "invitee"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "category_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayInput, {
    label: "Members",
    source: "members",
    sort: {
      field: 'name',
      order: 'ASC'
    },
    reference: "person",
    perPage: 40
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteArrayInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status",
    defaultValue: "active"
  })));
};

exports.listCreate = listCreate;

var listEdit = function listEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    label: "List",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_raInputRichText.default, {
    source: "description",
    label: "Description",
    toolbar: _constants.toolbarOpts
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "category_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayInput, {
    label: "Members",
    source: "members",
    sort: {
      field: 'name',
      order: 'ASC'
    },
    reference: "person",
    optionText: "name",
    perPage: 40
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteArrayInput, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status"
  })));
};

exports.listEdit = listEdit;

var listList = function listList(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.List, _extends({}, props, {
    exporter: false,
    filters: /*#__PURE__*/_react.default.createElement(ListFilter, null),
    bulkActionButtons: false,
    sort: {
      field: 'name',
      order: 'ASC'
    }
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "show"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "privacy"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "owner",
    sortable: false
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "category",
    sortable: false
  })));
};

exports.listList = listList;

var ListShowTabs = function ListShowTabs(_ref) {
  var record = _ref.record,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Show, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null),
    actions: /*#__PURE__*/_react.default.createElement(_raCustom.TopbarNoActions, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedShowLayout, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
    label: "discussion"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "message",
    target: "list_id",
    addLabel: false,
    fullWidth: true,
    perPage: 20,
    sort: {
      field: 'created',
      order: 'DESC'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "show",
    expand: /*#__PURE__*/_react.default.createElement(MessageDisplay, null)
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    source: "sender_id",
    reference: "person",
    sortBy: "created",
    link: "show"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "subject"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FunctionField, {
    source: "created",
    render: function render(record) {
      return /*#__PURE__*/_react.default.createElement(_reactMoment.default, {
        fromNow: true
      }, record.created);
    }
  }), "}")), record.rbac && record.rbac.includes('i') && /*#__PURE__*/_react.default.createElement(CreateMessageButton, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
    label: "members"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name",
    label: "List"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.RichTextField, {
    source: "description"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "privacy"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "category"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayField, {
    source: "members",
    reference: "person",
    perPage: 40
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SingleFieldList, {
    linkType: "show"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "name",
    label: "Members"
  }))), /*#__PURE__*/_react.default.createElement(_reactAdmin.EditButton, null))));
};

exports.ListShowTabs = ListShowTabs;

var listShow = function listShow(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.ShowController, props, function (controllerProps) {
    return /*#__PURE__*/_react.default.createElement(_reactAdmin.ShowView, _extends({
      actions: null,
      title: " "
    }, props, controllerProps), /*#__PURE__*/_react.default.createElement(ListShowTabs, props));
  });
};

exports.listShow = listShow;

var CreateMessageButton = function CreateMessageButton(_ref2) {
  var record = _ref2.record;
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/message/create',
      state: {
        record: {
          list_id: record.id
        }
      }
    }
  }, "Post");
};

var MessageDisplay = function MessageDisplay(_ref3) {
  var id = _ref3.id,
      record = _ref3.record,
      resource = _ref3.resource;
  return /*#__PURE__*/_react.default.createElement("div", {
    dangerouslySetInnerHTML: {
      __html: record.content
    }
  });
};

var ListFilter = function ListFilter(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Filter, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "category_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.SearchInput, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices
  }));
};

var _default = listCreate;
exports.default = _default;