"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pictureEdit = exports.pictureCreate = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _constants = require("../lib/constants");

var _media = require("../lib/media");

var _validate = require("../lib/validate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// created 2-feb-2020 by rich braun <docker@instantlinux.net>
var pictureCreate = function pictureCreate(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_media.MediaInput, null), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    multiline: true,
    source: "caption"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "secret"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "path",
    validate: _validate.validate64String
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "category_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status",
    defaultValue: "active"
  })));
};

exports.pictureCreate = pictureCreate;

var pictureEdit = function pictureEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ImageField, {
    source: "thumbnail50x50",
    label: "Thumbnail"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    multiline: true,
    source: "caption"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "category_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    source: "orientation",
    disabled: true,
    choices: [{
      id: 1,
      name: 'normal'
    }, {
      id: 3,
      name: 'inverted'
    }, {
      id: 5,
      name: '90 clockwise'
    }, {
      id: 7,
      name: '90 counterclockwise'
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.NumberInput, {
    source: "size",
    label: "File size",
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.NumberInput, {
    source: "height",
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.NumberInput, {
    source: "width",
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "model",
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_media.MediaInput, null)));
};

exports.pictureEdit = pictureEdit;
var _default = pictureCreate;
exports.default = _default;