"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.profileEdit = exports.profileCreate = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _constants = require("../lib/constants");

var _validate = require("../lib/validate");

var _raCustom = require("../lib/ra-custom");

var _excluded = ["item", "record"],
    _excluded2 = ["formData"],
    _excluded3 = ["formData"],
    _excluded4 = ["formData"],
    _excluded5 = ["formData"],
    _excluded6 = ["formData"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var profileCreate = function profileCreate(props) {
  var _ref = typeof props.location.state !== 'undefined' && props.location.state.record,
      uid = _ref.uid;

  var redirect = uid ? "/person/".concat(uid, "/2") : 'show';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, _extends({}, props, {
    title: "Add Profile Item"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: redirect
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "uid",
    reference: "person",
    disabled: true,
    filter: {
      id: sessionStorage.getItem('uid')
    },
    label: "User",
    default_value: uid
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(ProfileItemFields, {
    item: "lang"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "public"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status",
    defaultValue: "active"
  })));
};

exports.profileCreate = profileCreate;

var profileEdit = function profileEdit(props) {
  var uid = sessionStorage.getItem('uid');
  var redirect = uid ? "/person/".concat(uid, "/2") : '/list';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: redirect
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "uid",
    reference: "person",
    disabled: true,
    filter: {
      id: sessionStorage.getItem('uid')
    },
    label: "User",
    default_value: uid
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(ProfileItemFields, null), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "public"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status",
    defaultValue: "active"
  })));
};

exports.profileEdit = profileEdit;

var ProfileItemFields = function ProfileItemFields(_ref2) {
  var item = _ref2.item,
      record = _ref2.record,
      props = _objectWithoutProperties(_ref2, _excluded);

  var val = item ? item : record.item;
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "item",
    choices: _constants.profileChoices,
    defaultValue: val
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormDataConsumer, null, function (_ref3) {
    var formData = _ref3.formData,
        rest = _objectWithoutProperties(_ref3, _excluded2);

    return ['lang', 'location', 'pronouns', 'tz'].includes(formData.item) || /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
      source: "value",
      validate: _validate.validateRequired96String
    });
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormDataConsumer, null, function (_ref4) {
    var formData = _ref4.formData,
        rest = _objectWithoutProperties(_ref4, _excluded3);

    return formData.item === 'lang' && /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
      source: "value",
      choices: _constants.localeChoices,
      validate: _validate.validateSelected
    });
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormDataConsumer, null, function (_ref5) {
    var formData = _ref5.formData,
        rest = _objectWithoutProperties(_ref5, _excluded4);

    return formData.item === 'pronouns' && /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
      source: "value",
      choices: _constants.pronounChoices,
      validate: _validate.validateSelected
    });
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormDataConsumer, null, function (_ref6) {
    var formData = _ref6.formData,
        rest = _objectWithoutProperties(_ref6, _excluded5);

    return formData.item === 'location' && /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
      source: "location_id",
      reference: "location",
      validate: _validate.validateSelected
    }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
      optionText: "name"
    }));
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormDataConsumer, null, function (_ref7) {
    var formData = _ref7.formData,
        rest = _objectWithoutProperties(_ref7, _excluded6);

    return formData.item === 'tz' && /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
      source: "tz_id",
      reference: "tz",
      label: "Timezone",
      validate: _validate.validateSelected
    }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
      optionText: "name"
    }));
  }));
};

var _default = profileCreate;
exports.default = _default;