"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.settingsList = exports.settingsEdit = exports.settingsCreate = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _reactRouterDom = require("react-router-dom");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _registry = _interopRequireDefault(require("../lib/registry"));

var _constants = require("../lib/constants");

var _validate = require("../lib/validate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var settingsCreate = function settingsCreate(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validation: _validate.validateKeywordAlpha
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "public"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "smtp_smarthost"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.NumberInput, {
    source: "smtp_port"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "smtp_credential_id",
    label: "SMTP credential",
    reference: "credential",
    allowEmpty: true
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "administrator_id",
    reference: "person"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "smtp_sender"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "country"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "tz_id",
    reference: "tz"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "url",
    type: "url",
    label: "URL"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "default_cat_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "window_title"
  })));
};

exports.settingsCreate = settingsCreate;

var settingsEdit = function settingsEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: "Settings"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "settings"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validation: _validate.validateKeywordAlpha
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    source: "privacy",
    label: "Default privacy",
    choices: _constants.privacyChoices,
    defaultValue: "public"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "smtp_smarthost",
    label: "SMTP smarthost"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.NumberInput, {
    source: "smtp_port",
    label: "SMTP port"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "smtp_credential_id",
    label: "SMTP credential",
    reference: "credential",
    allowEmpty: true
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "administrator_id",
    reference: "person"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "country"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "lang",
    label: "Default language",
    choices: [{
      id: 'zh',
      name: 'Chinese'
    }, {
      id: 'en_US',
      name: 'English'
    }, {
      id: 'fr',
      name: 'French'
    }, {
      id: 'de',
      name: 'German'
    }, {
      id: 'pt',
      name: 'Portuguese'
    }, {
      id: 'es',
      name: 'Spanish'
    }],
    defaultValue: "en_US"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "tz_id",
    reference: "tz",
    label: "Default timezone"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "url",
    label: "URL"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "window_title"
  }), (0, _registry.default)('storage') && /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "default_storage_id",
    reference: "storage",
    label: "Default storage volume"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "default_hostlist_id",
    reference: "list",
    label: "Default hostlist"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "default_cat_id",
    reference: "category",
    label: "Default category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  }))), (0, _registry.default)('storage') && /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "Storage",
    toolbar: null
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "storage",
    target: "uid",
    filter: {
      uid: sessionStorage.getItem('uid')
    },
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "prefix"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "bucket"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "privacy"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    source: "credentials_id",
    reference: "credential"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  }))), /*#__PURE__*/_react.default.createElement(CreateStorageButton, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "Credentials",
    toolbar: null
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "credential",
    target: "settings_id",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "vendor"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "key",
    emptyText: " "
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "type",
    emptyText: " "
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "expires"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  }))), /*#__PURE__*/_react.default.createElement(CreateCredentialButton, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "Scopes",
    toolbar: null
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "scope",
    target: "settings_id",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  }))), /*#__PURE__*/_react.default.createElement(CreateScopeButton, null))));
};

exports.settingsEdit = settingsEdit;

var settingsList = function settingsList(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.List, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "privacy"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.NumberField, {
    source: "smtp_port"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "smtp_smarthost"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.UrlField, {
    source: "url"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "window_title"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "owner",
    sortable: false
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "created"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "modified"
  })));
};

exports.settingsList = settingsList;

var CreateCredentialButton = function CreateCredentialButton(_ref) {
  var record = _ref.record;
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/credential/create',
      state: {
        record: {
          settings_id: record.id
        }
      }
    }
  }, "Add");
};

var CreateScopeButton = function CreateScopeButton(_ref2) {
  var record = _ref2.record;
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/scope/create'
    }
  }, "Add");
};

var CreateStorageButton = function CreateStorageButton(_ref3) {
  var record = _ref3.record;
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/storage/create'
    }
  }, "Add");
};

var _default = settingsCreate;
exports.default = _default;