"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.storageEdit = exports.storageCreate = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _constants = require("../lib/constants");

var _validate = require("../lib/validate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var storageCreate = function storageCreate(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/settings/".concat(sessionStorage.getItem('settings_id'), "/1")
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "prefix"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "bucket",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "cdn_uri",
    label: "CDN service URL",
    validate: _validate.validateURI
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "identifier",
    validate: _validate.validate64String
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "public"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "credentials_id",
    reference: "credential",
    validate: _validate.validateSelected
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  }))));
};

exports.storageCreate = storageCreate;

var storageEdit = function storageEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(MenuTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/settings/".concat(sessionStorage.getItem('settings_id'), "/1")
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "prefix"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "bucket",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "cdn_uri",
    label: "CDN service URL",
    validate: _validate.validateURI
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "identifier",
    validate: _validate.validate64String
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "credentials_id",
    reference: "credential",
    validate: _validate.validateSelected
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "status",
    choices: [{
      id: 'active',
      name: 'active'
    }, {
      id: 'disabled',
      name: 'disabled'
    }]
  })));
};

exports.storageEdit = storageEdit;

var MenuTitle = function MenuTitle(_ref) {
  var record = _ref.record;
  return /*#__PURE__*/_react.default.createElement("span", null, record ? "Storage: ".concat(record.name) : '');
};

var _default = storageCreate;
exports.default = _default;