"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.trashcanList = exports.trashcanEdit = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _reactMoment = _interopRequireDefault(require("react-moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var trashcanEdit = function trashcanEdit(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "resource",
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "status",
    choices: [{
      id: 'active',
      name: 'active'
    }, {
      id: 'disabled',
      name: 'disabled'
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    source: "uid",
    reference: "person",
    label: "Owner"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "name"
  }))));
};

exports.trashcanEdit = trashcanEdit;

var trashcanList = function trashcanList(props) {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.List, _extends({}, props, {
    bulkActionButtons: false,
    filters: /*#__PURE__*/_react.default.createElement(TrashFilter, null),
    filterDefaultValues: {
      resource: 'list'
    }
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "resource"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.FunctionField, {
    source: "created",
    render: function render(record) {
      return /*#__PURE__*/_react.default.createElement(_reactMoment.default, {
        fromNow: true
      }, record.created);
    }
  }), "}", /*#__PURE__*/_react.default.createElement(_reactAdmin.FunctionField, {
    source: "modified",
    render: function render(record) {
      return record.modified && /*#__PURE__*/_react.default.createElement(_reactMoment.default, {
        fromNow: true
      }, record.modified);
    }
  }), "}"));
};

exports.trashcanList = trashcanList;

var TrashFilter = function TrashFilter(props) {
  var resources = [];
  Object.keys(JSON.parse(sessionStorage.getItem('resource_endpoints'))).forEach(function (resource) {
    ['auth', 'grant', 'metric', 'scope', 'settings', 'trashcan', 'tz'].includes(resource) || resources.push({
      id: resource,
      name: resource
    });
  });
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Filter, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    source: "resource",
    choices: resources,
    allowEmpty: false,
    alwaysOn: true
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "uid",
    reference: "person",
    label: "Person"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    optionText: "name"
  })));
};

var _default = trashcanList;
exports.default = _default;