"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _raCore = require("ra-core");

var _reactFinalForm = require("react-final-form");

var _reactRouterDom = require("react-router-dom");

var _core = require("@material-ui/core");

var _constants = require("../lib/constants");

var _excluded = ["meta", "input"],
    _excluded2 = ["redirectTo"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var QRCode = require('qrcode.react');

var MFAGenerate = /*#__PURE__*/function (_React$Component) {
  _inherits(MFAGenerate, _React$Component);

  var _super = _createSuper(MFAGenerate);

  function MFAGenerate(props) {
    var _this;

    _classCallCheck(this, MFAGenerate);

    _this = _super.call(this, props);
    _this.state = {
      data: null
    };
    return _this;
  }

  _createClass(MFAGenerate, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var uid = sessionStorage.getItem('uid');
      var token = sessionStorage.getItem('token');
      var request = new Request(_constants.apiUrl + '/auth_totp', {
        headers: new Headers({
          Accept: 'application/json',
          Authorization: 'Basic ' + btoa(uid + ':' + token)
        })
      }); // TODO handle errors

      fetch(request).then(function (response) {
        return response.json();
      }).then(function (data) {
        return _this2.setState({
          uri: data.uri,
          nonce: data.jti
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          nonce = _this$state.nonce,
          uri = _this$state.uri;
      sessionStorage.setItem('nonce', nonce);

      if (uri) {
        return /*#__PURE__*/_react.default.createElement("div", null, "Scan this QR code on your authenticator app", /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement(QRCode, {
          renderAs: 'svg',
          value: uri,
          size: 192
        }));
      } else {
        return '';
      }
    }
  }]);

  return MFAGenerate;
}(_react.default.Component);

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    button: {
      width: '100%',
      marginTop: theme.spacing(1)
    },
    icon: {
      marginRight: theme.spacing(1)
    }
  };
}, {
  name: 'MFARegister'
});

var Input = function Input(_ref) {
  var _ref$meta = _ref.meta,
      touched = _ref$meta.touched,
      error = _ref$meta.error,
      inputProps = _ref.input,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react.default.createElement(_core.TextField, _extends({
    error: !!(touched && error),
    helperText: touched && error
  }, inputProps, props));
};

var MFA = function MFA(_ref2) {
  var redirectTo = _ref2.redirectTo,
      props = _objectWithoutProperties(_ref2, _excluded2);

  var classes = useStyles(props);

  var _useSafeSetState = (0, _reactAdmin.useSafeSetState)(false),
      _useSafeSetState2 = _slicedToArray(_useSafeSetState, 2),
      loading = _useSafeSetState2[0],
      setLoading = _useSafeSetState2[1];

  var _useSafeSetState3 = (0, _reactAdmin.useSafeSetState)(false),
      _useSafeSetState4 = _slicedToArray(_useSafeSetState3, 2),
      registered = _useSafeSetState4[0],
      setRegistered = _useSafeSetState4[1];

  var _useSafeSetState5 = (0, _reactAdmin.useSafeSetState)(false),
      _useSafeSetState6 = _slicedToArray(_useSafeSetState5, 2),
      totp_toggle = _useSafeSetState6[0],
      setTotpToggle = _useSafeSetState6[1];

  var _useSafeSetState7 = (0, _reactAdmin.useSafeSetState)(null),
      _useSafeSetState8 = _slicedToArray(_useSafeSetState7, 2),
      backup_codes = _useSafeSetState8[0],
      setBackupCodes = _useSafeSetState8[1];

  var _useSafeSetState9 = (0, _reactAdmin.useSafeSetState)(redirectTo),
      _useSafeSetState10 = _slicedToArray(_useSafeSetState9, 2),
      redir = _useSafeSetState10[0],
      setRedir = _useSafeSetState10[1];

  var history = (0, _reactRouterDom.useHistory)();
  var notify = (0, _raCore.useNotify)();
  var translate = (0, _reactAdmin.useTranslate)();
  var uid = sessionStorage.getItem('uid');
  var token = sessionStorage.getItem('token');
  var authHeaders = new Headers({
    Accept: 'application/json',
    Authorization: 'Basic ' + btoa(uid + ':' + token),
    'Content-Type': 'application/json'
  });

  var validate = function validate(values) {
    var errors = {
      otp_first: undefined
    };
    var digits = new RegExp('^[0-9]+$');

    if (!values.otp_first) {
      errors.otp_first = translate('ra.validation.required');
    }

    if (values.otp_first && (values.otp_first.length !== 6 || !digits.test(values.otp_first))) {
      errors.otp_first = 'Enter 6 digits';
    }

    return errors;
  };

  function register(_ref3) {
    var otp_first = _ref3.otp_first;
    var nonce = sessionStorage.getItem('nonce');
    var auth = sessionStorage.getItem('auth');
    sessionStorage.removeItem('nonce');
    var request = new Request(_constants.apiUrl + '/auth_totp', {
      method: 'POST',
      body: JSON.stringify({
        otp_first: otp_first,
        nonce: nonce
      }),
      headers: authHeaders
    });
    return fetch(request).then(function (response) {
      if (!response.ok) {
        throw Error(response.json().message);
      }

      return response.json();
    }).then(function (json) {
      setBackupCodes(json.backup_codes.join("\n"));
      setRegistered(true);

      if (auth && auth.includes('mfarequired')) {
        setRedir('/logout');
        sessionStorage.removeItem('auth');
        sessionStorage.removeItem('token');
      }

      return json;
    });
  }

  function isRegistered() {
    var request = new Request(_constants.apiUrl + "/account?filter={\"uid\":\"".concat(uid, "\"}"), {
      headers: authHeaders
    }); // TODO handle errors

    return fetch(request).then(function (response) {
      return response.json();
    }).then(function (json) {
      setRegistered(json.items[0].totp); // TODO: maybe allow a user to toggle MFA off

      if (registered) {
        setTotpToggle(true);
      }
    }).catch(console.error);
  }

  var submit = function submit(values) {
    setLoading(true);
    register(values, redirectTo).then(function () {
      setLoading(false);
    }).catch(function (error) {
      setLoading(false);
      notify(typeof error === 'string' ? error : typeof error === 'undefined' || !error.message ? 'ra.auth.sign_in_error' : error.message, 'warning', {
        _: typeof error === 'string' ? error : error && error.message ? error.message : undefined
      });
    });
  }; // TODO this apparently re-invokes endpoint each reference to var registered,
  //and does it 5+ times


  isRegistered(); // TODO: deal with warning
  // Failed prop type: Invalid prop `children` supplied to `ForwardRef(CardContent)`, expected a ReactNode.

  return /*#__PURE__*/_react.default.createElement(_core.Card, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Title, {
    title: "MFA"
  }), /*#__PURE__*/_react.default.createElement(_core.CardContent, null, totp_toggle && (registered || /*#__PURE__*/_react.default.createElement(MFAGenerate, null))), /*#__PURE__*/_react.default.createElement(_core.CardContent, null, /*#__PURE__*/_react.default.createElement(_reactFinalForm.Form, {
    onSubmit: submit,
    validate: validate,
    render: function render(_ref4) {
      var handleSubmit = _ref4.handleSubmit;
      return /*#__PURE__*/_react.default.createElement("form", {
        onSubmit: handleSubmit,
        noValidate: true
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.form
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.input
      }, "Enable TOTP? ", /*#__PURE__*/_react.default.createElement(_core.Switch, {
        id: "totp_enabled",
        name: "totp_enabled",
        onChange: function onChange(_, value) {
          return setTotpToggle(value);
        },
        disabled: loading,
        checked: totp_toggle
      })), totp_toggle && (registered || /*#__PURE__*/_react.default.createElement("div", {
        className: classes.input
      }, /*#__PURE__*/_react.default.createElement(_reactFinalForm.Field, {
        autoFocus: true,
        id: "otp_first",
        name: "otp_first",
        label: "Enter Verification Code",
        disabled: loading,
        component: Input
      })))), backup_codes && /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(ShowBackupCodes, {
        backup_codes: backup_codes
      })), /*#__PURE__*/_react.default.createElement(_core.CardActions, null, /*#__PURE__*/_react.default.createElement(_core.Button, {
        variant: "contained",
        type: "submit",
        color: "primary",
        disabled: loading,
        onClick: function onClick() {
          return (!totp_toggle || registered) && history.push(redir);
        },
        className: classes.icon
      }, !totp_toggle || registered ? translate('ra.action.close') : translate('ra.action.confirm'))));
    }
  })));
};

var ShowBackupCodes = function ShowBackupCodes(_ref5) {
  var backup_codes = _ref5.backup_codes;
  return /*#__PURE__*/_react.default.createElement(_core.Card, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Title, {
    title: " - Your backup access tokens"
  }), /*#__PURE__*/_react.default.createElement(_core.CardContent, null, /*#__PURE__*/_react.default.createElement(_core.Box, {
    color: "primary.main",
    bgcolor: "#70ff70",
    fontFamily: "Monospace",
    p: {
      xs: 2,
      sm: 3,
      md: 4
    },
    style: {
      whiteSpace: "pre-line"
    }
  }, backup_codes), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement("br", null), "Save these single-use codes into a password vault - they cannot be displayed again", /*#__PURE__*/_react.default.createElement("br", null)));
};

MFA.defaultProps = {
  redirectTo: "/account_password/".concat(sessionStorage.getItem('uid'))
};
var _default = MFA;
exports.default = _default;