"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _reactAdmin = require("react-admin");

var _queryString = _interopRequireDefault(require("query-string"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// created 20-may-2019 by rich braun <docker@instantlinux.net>
var welcome = function welcome() {
  var search = window.location.hash.split('?');
  var buttons = null;

  if (search.length > 1) {
    var query = _queryString.default.parse(search[1]);

    buttons = 'buttons' in query && query.buttons;

    if (buttons && buttons.includes('login')) {
      // Came here from accountPassword reset: logout
      sessionStorage.removeItem('token');
      sessionStorage.removeItem('uid');
    }
  }

  var uid = sessionStorage.getItem('uid');
  var auth = sessionStorage.getItem('auth');
  return /*#__PURE__*/_react.default.createElement(_Card.default, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Title, {
    title: "Example"
  }), /*#__PURE__*/_react.default.createElement(_CardContent.default, null, "This is an example message-board application with a python REST backend and a React frontend. You can build your own full-stack applications by adding new schema and logic to the models, views and controllers. Make them secure by customizing the RBAC and privacy features of instantlinux/apicrud.", (!uid || buttons && buttons.includes('login')) && /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      textAlign: 'center'
    }
  }, /*#__PURE__*/_react.default.createElement(LoginButton, null), " ", /*#__PURE__*/_react.default.createElement(ForgotPWButton, null))), uid !== null && auth && auth.match(/pwchange/) && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      textAlign: 'center'
    }
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/account_password/' + uid + '/edit'
    }
  }, "Set Password")), /*#__PURE__*/_react.default.createElement("p", null), uid === null && /*#__PURE__*/_react.default.createElement("div", null, "You do not need an account to respond to invitations. If you received a link by email, SMS or another contact method, click on that link.", /*#__PURE__*/_react.default.createElement("p", null), "With an account, you can create lists and invite people to them.")));
};

var LoginButton = function LoginButton() {
  // TODO this translate isn't working here
  // const translate = useTranslate();
  //  {translate('ra.auth.sign_in')}
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: "/login"
  }, "Sign In");
};

var ForgotPWButton = function ForgotPWButton() {
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: "/account/create?forgot=true"
  }, "Forgot Password");
};

var _default = welcome;
exports.default = _default;